/***************************************************************
 * Name:      DragDropTreeCtrl.h
 * Purpose:   Defines Dialog DragDropTreeCtrl
 * Author:    Salvador Pozo (salvador@conclase.net)
 * Created:   2025-05-30
 * Copyright: Salvador Pozo (www.conclase.net)
 * License:
 **************************************************************/

#ifndef DRAGDROPTREECTRL_H
#define DRAGDROPTREECTRL_H

#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif

//#define wxUSE_TREECTRL TRUE
#include <wx/treectrl.h>
#include <wx/generic/treectlg.h>
#include "EditTreeCtrl.h"


class DragDropTreeCtrl : public wxDialog
{
    protected:
        enum
        {
            idTreeCtrl = 1000
        };
        wxGenericTreeCtrl* arbol;
        std::vector<TreeData2> &datos;
        //std::vector<TreeData2*> dataItem;
        wxString &cadena;
        wxTreeItemId origen;
        wxTreeItemId destino;
        wxTreeItemId padre;

    public:
        DragDropTreeCtrl(wxWindow *wnd, std::vector<TreeData2> &data, wxString &cad);
        virtual ~DragDropTreeCtrl();
        void OnOk(wxCommandEvent& event);

    private:
        void InsertarElementos();
        void LeerArbol(const wxTreeItemId& idParent, wxTreeItemIdValue cookie=0);
        void BuscaNodo(int id, const wxTreeItemId& nodo, wxTreeItemIdValue cookie=0);
        void CopiaHijos(wxTreeItemId origen, wxTreeItemId destino);
        void OnClose(wxCloseEvent& event);
        void OnBeginDrag(wxTreeEvent& event);
        void OnEndDrag(wxTreeEvent& event);
        wxDECLARE_EVENT_TABLE();
};

#endif // DRAGDROPTREECTRL_H
