/***************************************************************
 * Name:      EditTreeCtrl.h
 * Purpose:   Defines Dialog EditTreeCtrl
 * Author:    Salvador Pozo (salvador@conclase.net)
 * Created:   2025-05-29
 * Copyright: Salvador Pozo (www.conclase.net)
 * License:
 **************************************************************/

#ifndef EDITTREECTRL_H
#define EDITTREECTRL_H

#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif

//#define wxUSE_TREECTRL TRUE
#include <wx/treectrl.h>
#include <wx/generic/treectlg.h>

class TreeData2 : public wxTreeItemData {
private:
    int id;
    int idpadre;
    wxString etiqueta;
    wxTreeItemId itemId;
public:
    TreeData2(int i, int p, const wxString etq) : id(i), idpadre(p), etiqueta(etq), itemId(0) {}
    // El constructor copia es necesario para operaciones de drag & drop
    TreeData2(const TreeData2& c) { id=c.id; idpadre=c.idpadre; etiqueta=c.etiqueta; itemId=c.itemId; }
    int Id() const { return id; }
    int Padre() const { return idpadre; }
    wxString& Etiqueta() { return etiqueta; }
    void SetEtiqueta(const wxString &equ) { etiqueta = equ; }
    void SetPadre(int p) { idpadre = p; }
    void SetItemId(wxTreeItemId id) { itemId = id; }
    wxTreeItemId GetItemId() const { return itemId; }
};

class EditTreeCtrl : public wxDialog
{
    protected:
        enum
        {
            idTreeCtrl = 1000
        };
        wxGenericTreeCtrl* arbol;
        std::vector<TreeData2> &datos;
        std::vector<TreeData2*> dataItem;
        wxString &cadena;

    public:
        EditTreeCtrl(wxWindow *wnd, std::vector<TreeData2> &data, wxString &cad);
        virtual ~EditTreeCtrl();
        void OnOk(wxCommandEvent& event);

    private:
        void InsertarElementos();
        void OnClose(wxCloseEvent& event);
        void OnBeginEditLabel(wxTreeEvent& event);
        void OnEndEditLabel(wxTreeEvent& event);

        void OnBeginDrag(wxTreeEvent& event);
        void OnEndDrag(wxTreeEvent& event);
        wxDECLARE_EVENT_TABLE();
};

#endif // EDITTREECTRL_H
