/***************************************************************
 * Name:      GenericTreeCtrl.h
 * Purpose:   Defines Dialog GenericTreeCtrl
 * Author:    Salvador Pozo (salvador@conclase.net)
 * Created:   2025-05-27
 * Copyright: Salvador Pozo (www.conclase.net)
 * License:
 **************************************************************/

#ifndef GENERICTREECTRL_H
#define GENERICTREECTRL_H

#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif

//#define wxUSE_TREECTRL TRUE
#include <wx/treectrl.h>
#include <wx/generic/treectlg.h>

class GenericTreeCtrl : public wxDialog
{
    protected:
        enum
        {
            idTreeCtrl = 1000,
        };
        wxString &cadena;
        wxGenericTreeCtrl* arbol;

    public:
        GenericTreeCtrl(wxWindow *wnd, wxString &cad);
        virtual ~GenericTreeCtrl();
        void OnOk(wxCommandEvent& event);

    private:
        void AsignaIconosRama(const wxTreeItemId &nodo);
        void OnClose(wxCloseEvent& event);
        wxDECLARE_EVENT_TABLE();
};

#endif // GENERICTREECTRL_H
