/***************************************************************
 * Name:      TreeCtrl.h
 * Purpose:   Defines Dialog TreeCtrl
 * Author:    Salvador Pozo (salvador@conclase.net)
 * Created:   2025-05-26
 * Copyright: Salvador Pozo (www.conclase.net)
 * License:
 **************************************************************/

#ifndef TREECTRL_H
#define TREECTRL_H

#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif

#include <wx/treectrl.h>

class TreeCtrl : public wxDialog
{
    protected:
        enum
        {
            idTreeCtrl = 1000,
        };
        wxString &cadena;
        wxTreeCtrl* arbol;

    public:
        TreeCtrl(wxWindow *wnd, wxString &cad);
        virtual ~TreeCtrl();
        void OnOk(wxCommandEvent& event);

    private:
        void AsignaIconosRama(const wxTreeItemId &nodo);
        void OnClose(wxCloseEvent& event);
        wxDECLARE_EVENT_TABLE();
};

#endif // TREECTRL_H
