/***************************************************************
 * Name:      wx022Main.h
 * Purpose:   Defines Application Frame
 * Author:    Salvador Pozo (salvador@conclase.net)
 * Created:   2025-05-23
 * Copyright: Salvador Pozo (https://conclase.net)
 * License:
 **************************************************************/

#ifndef WX022MAIN_H
#define WX022MAIN_H

#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif

#include "wx022App.h"
#include "TreeCtrl.h"
#include "GenericTreeCtrl.h"
#include "OrdenTreeCtrl.h"
#include "EditTreeCtrl.h"
#include "DragDropTreeCtrl.h"

class wx022Frame: public wxFrame
{
    public:
        wx022Frame(wxFrame *frame, const wxString& title);
        ~wx022Frame();
    private:
        std::vector<TreeData> datos;
        std::vector<TreeData2> datos2;
        enum
        {
            idMenuQuit = 1000,
            idMenuTreeCtrl,
            idMenuGenericTree,
            idMenuOrdenTree,
            idMenuEditTree,
            idMenuDragDropTree,
            idMenuAbout
        };
        void OnTreeCtrl(wxCommandEvent& event);
        void OnGenericTreeCtrl(wxCommandEvent& event);
        void OnOrdenTreeCtrl(wxCommandEvent& event);
        void OnEditTreeCtrl(wxCommandEvent& event);
        void OnDragDropTreeCtrl(wxCommandEvent& event);
        void OnClose(wxCloseEvent& event);
        void OnQuit(wxCommandEvent& event);
        void OnAbout(wxCommandEvent& event);
        DECLARE_EVENT_TABLE()
};


#endif // WX022MAIN_H
